--TEST--
Gracefully handle out-of-sync spans in closure itself [user][default properties]
--ENV--
DD_TRACE_LOG_LEVEL=info,startup=off
--FILE--
<?php

DDTrace\trace_function('shutdown_and_flush', function (DDTrace\SpanData $span) {
    /* This frees the struct holding $span; ensure we don't segfault as this is
     * akin to what we actually do in real scenarios.
     */
    dd_trace_serialize_closed_spans();
});

function shutdown_and_flush() {}
shutdown_and_flush();

echo 'Done.' . PHP_EOL;
?>
--EXPECT--
Done.
[ddtrace] [info] No finished traces to be sent to the agent
